﻿--[[
MakeMods is an add-on written specifically for officers of the guild Kinder der Nacht
on the European realm Das Konsortium. For every calendar event MakeMods automatically
promotes the guild's officers to Moderator status. That's it.

MakeMods may become public at a later date. So far it's not.

Since MakeMods is designed for internal use it doesn't have any configuration
whatsoever. The guild's officers know how to use it, that's good enough. The
add-on builds a list of all guild members with guild ranks 0, 1, 2 and 3. For
Kinder der Nacht on EU-Das Konsortium this happens to include all officers.

If you're playing somewhere else MakeMods won't do anything. It only acts if the
function kdn() returns true, i.e. if the player is a member of Kinder der Nacht and
is a Horde character and is logged into Das Konsortium.

In case you'd like to adopt the add-on for your own purposes, feel free to change it.
It isn't much and it isn't particularly complex but even so, if you do run into
something you don't understand, I don't provide documentation or help ;-)

All the best,

Contiki
Kinder der Nacht
EU-Das Konsortium
]]

local mm = {}
local playerarrived = false

local function msg(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg)
end

function makemods_onload(self)
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("GUILD_ROSTER_UPDATE")
	self:RegisterEvent("CALENDAR_ACTION_PENDING")
end

local function kdn()
	local guild = GetGuildInfo("player")
	local faction = UnitFactionGroup("player")
	local realm = GetRealmName()
	if guild == "Kinder der Nacht" and faction == "Horde" and realm == "Das Konsortium" then
		return true
	end
	return false
end

local function makemods()
	if mm then
		local inv = CalendarEventGetNumInvites()
		local invitee, ismod = nil
		for i=1, inv do
			invitee,_,_,_,_,ismod = CalendarEventGetInvite(i)
			for _,v in ipairs(mm) do
				if invitee == v and invitee ~= GetUnitName("player") and CalendarEventCanModerate(i) and ismod ~= "MODERATOR" and ismod ~= "CREATOR" then
					CalendarEventSetModerator(i)
				end
			end
		end
	end
end

function makemods_onevent(self, event, ...)
	if event == "PLAYER_ENTERING_WORLD" then
		playerarrived = true
		self:UnregisterEvent("PLAYER_ENTERING_WORLD")
	elseif event == "GUILD_ROSTER_UPDATE" then
		if playerarrived then
			mm = {}
			local num = GetNumGuildMembers(1)
			if num > 0 then
				for i = 1, num do
					local rostername, rosterrank, rosterrankindex = GetGuildRosterInfo(i)
					if rostername and rosterrankindex <= 3 then
						table.insert(mm, rostername)
					end
				end
			end
		else
			GuildRoster()
		end
	elseif event == "CALENDAR_ACTION_PENDING" then
		if kdn() then
			makemods()
		end
	end
end